#!/usr/bin/perl -w

use strict;
use warnings;
use CryptoPhotoUtils;	  # n.b. CryptoPhotoUtils.pm goes in your "site_perl" folder, eg: /usr/lib/perl5/site_perl/
use LWP::Simple;

our $VERSION = '1.20131122';

my $public_key = '__PUBLIC_KEY__';    # Get these from https://cryptophoto.com/admin/account
my $private_key = '__PRIVATE_KEY__';

my $uid = '123456';			# This is the UserID of your customer. (It does not get revealed)

my $cp = new CryptoPhotoUtils("https://cryptophoto.com", $private_key, $public_key, $uid);

my $ip;
$ip = $ENV{'REMOTE_ADDR'};		# Adjust this to get the customer's IP address from your web server environment

# The below is for testing in a shell - remove this line if you put this into a web page
$ip = &LWP::Simple::get('https://cp.vu/show_my_ip');	# Gets your current (external) IP address

# Request a new CP session 
my $r = $cp->start_session($ip, 1);

if($r->{is_valid}) {
  print "Session ID: ". $r->{sid} ."\n";    # You need this for calls to CP

  print "\n";

  $html = $cp->get_auth_widget();
  print "Auth Token Form: ". $html ."\n";   # So is this
  
} 
else {
  print "Error: ". $r->{error} ."\n";
}


$r = $cp->start_session($ip);

if($r->{is_valid}) {
  print "Session ID: ". $r->{sid} ."\n";    # You need this for calls to CP

  print "\n";

  my $html = $cp->get_gen_widget();
  print "Generate Token Form: ". $html ."\n";   # This is HTML for your web page to use

}
else {
  print "Error: ". $r->{error} ."\n";
}


# Verifies the response to a given challenge
# This is just a demo of how the function should be used;  without valid
# parameters, it is natural that it will return an error message, it is
# supposed to work when integrated with the login, when you provide
# a real, valid IP and valid authentication codes.  
$r = $cp->verify_response('selector', 'response_row', 'response_col', 'cp_phc', $ip);

print "\n";

if($r->{is_valid}) {
  print "Authenticated\n";
} else {
  print "Error: ". $r->{error} ."\n";
}
